<template>
  <!-- text || number -->
  <div
    v-if="cellType === 'text' || cellType === 'number'"
    :class="[getClass(), cellWidth ? `w-${cellWidth}px` : '']"
  >
    <svn-pro-text
      :regular="regular"
      :medium="medium"
      :body-medium="bodyMedium"
      :body-large="bodyLarge"
      color="onSurface"
      class="line-clamp-1 break-all"
    >
      {{ text }}
    </svn-pro-text>
  </div>

  <!-- text + supporting text -->
  <div
    v-if="cellType === 'text_supporting_text'"
    :class="[getClass(), cellWidth ? `w-${cellWidth}px` : '']"
  >
    <svn-pro-text
      :regular="regular"
      :medium="medium"
      :body-medium="bodyMedium"
      :body-large="bodyLarge"
      color="onSurface"
      class="line-clamp-1 break-all"
    >
      {{ text }}
    </svn-pro-text>

    <svn-pro-text
      caption
      color="onSurfaceVariant"
      class="line-clamp-1 break-all"
    >
      {{ supportingText }}
    </svn-pro-text>
  </div>

  <!-- avatar + text || avatar + text + supporting text -->
  <div
    v-if="cellType === 'avatar_text' || cellType === 'avatar_text_supporting_text'"
    :class="[getClass(), cellWidth ? `w-${cellWidth}px` : '']"
  >
    <svn-pro-avatar
      :size="24"
      :image="avatar"
      :firstname="text"
      :type="anonym ? 'anonym' : avatar ? 'photo' : 'monogram'"
    />

    <div class="flex flex-col">
      <svn-pro-text
        :regular="regular"
        :medium="medium"
        :body-medium="bodyMedium"
        :body-large="bodyLarge"
        color="onSurface"
        class="line-clamp-1 break-all"
      >
        {{ text }}
      </svn-pro-text>

      <svn-pro-text
        v-if="cellType === 'avatar_text_supporting_text'"
        caption
        color="onSurfaceVariant"
        class="line-clamp-1 break-all"
      >
        {{ supportingText }}
      </svn-pro-text>
    </div>
  </div>

  <!-- emoji + text || emoji + text + supporting text -->
  <div
    v-if="cellType === 'emoji_text' || cellType === 'emoji_text_supporting_text'"
    :class="[getClass(), cellWidth ? `w-${cellWidth}px` : '']"
  >
    <div>
      <Icon
        :icon="emoji"
        height="24"
        width="24"
      />
    </div>

    <div class="flex flex-col">
      <svn-pro-text
        :regular="regular"
        :medium="medium"
        :body-medium="bodyMedium"
        :body-large="bodyLarge"
        color="onSurface"
        class="line-clamp-1 break-all"
      >
        {{ text }}
      </svn-pro-text>

      <svn-pro-text
        v-if="cellType === 'emoji_text_supporting_text'"
        caption
        color="onSurfaceVariant"
        class="line-clamp-1 break-all"
      >
        {{ supportingText }}
      </svn-pro-text>
    </div>
  </div>

  <!-- info tag -->
  <div
    v-if="cellType === 'info_tag'"
    :class="[getClass(), cellWidth ? `w-${cellWidth}px` : '']"
  >
    <svn-pro-info-tag
      :text="text"
      :break-all="breakAll"
      :tag-type="tagType"
      :tag-size="tagSize"
      :leading-item="leadingItem"
    />
  </div>

  <!-- icon button -->
  <div
    v-if="cellType === 'icon_button'"
    :class="[getClass(), 'w-fit']"
  >
    <svn-pro-icon-button
      :icon="icon"
      variant="flat"
      color="transparent"
    />
  </div>
</template>

<script setup>
import { Icon } from '@iconify/vue';
import SvnProText from '../styles/SvnProText.vue';
import SvnProAvatar from '../avatar/SvnProAvatar.vue';
import SvnProInfoTag from '../chip/SvnProInfoTag.vue';
import SvnProIconButton from '../button/SvnProIconButton.vue';

const props = defineProps({
  text: {
    type: String,
    default: "text"
  },
  supportingText: {
    type: String,
    default: "Supporting text"
  },
  avatar: {
    type: String,
    default: undefined,
  },
  emoji: {
    type: String,
    default: "noto:fire",
  },
  tagType: {
    type: String,
    default: "info",
  },
  tagSize: {
    type: String,
    default: "compact",
  },
  regular: {
    type: Boolean, 
    default: false,
  },
  anonym: {
    type: Boolean, 
    default: false,
  },
  medium: {
    type: Boolean, 
    default: false,
  },
  bodyMedium: {
    type: Boolean, 
    default: false,
  },
  bodyLarge: {
    type: Boolean, 
    default: false,
  },
  icon: {
    type: String,
    default: "$vuetify",
  },
  leadingItem: {
    type: String, 
    default: undefined,
  },
  cellType: {
    type: String,
    default: "text"
  },
  cellWidth: {
    type: Number,
    default: 160
  },
  tagItems: {
    type: Array,
    default: () => [],
  },
  breakAll: {
    type: Boolean,
    default: true,
  },
})

const getClass = () => {
  switch (props.cellType) {
    case "text":
      return "flex flex-col justify-center items-start"
    case "number":
      return "flex flex-col justify-center items-start"
    case "text_supporting_text":
      return "flex flex-col justify-center items-start"
    case "avatar_text":
      return "flex justify-start items-center gap-2"
    case "emoji_text":
      return "flex justify-start items-center gap-2"
    case "avatar_text_supporting_text":
      return "flex justify-start items-center gap-2"
    case "emoji_text_supporting_text":
      return "flex justify-start items-center gap-2"
    case "info_tag":
      return "flex justify-start items-center gap-2"
    case "icon_button":
      return "flex flex-col justify-center items-start"
  }
}
</script>